%bcond_with lpthreadhack

Name:           xmms
Version:        1.2.11
Release:        40.5
Epoch:          1
Summary:        The X MultiMedia System, a media player

Group:          Applications/Multimedia
License:        GPLv2
URL:            http://www.xmms.org/
Source0:        http://www.xmms.org/files/1.2.x/%{name}-%{version}.tar.bz2
Source1:        xmms.sh
Source2:        xmms.xpm
Source3:        xmms.desktop
Patch0:         %{name}-1.2.11-dso.patch
# http://cvs.xmms.org/cvsweb.cgi/xmms/General/joystick/joy.c.diff?r1=1.8&r2=1.9
Patch1:         %{name}-1.2.6-audio.patch
Patch2:         %{name}-1.2.6-lazy.patch
Patch3:         %{name}-1.2.8-default-skin.patch
Patch5:         %{name}-1.2.11-arts.patch
Patch6:         %{name}-1.2.11-alsalib.patch
Patch7:         %{name}-cd-mountpoint.patch
# Patch8 on top of patch4
Patch8:         %{name}-1.2.11-multidevel.patch
Patch9:         %{name}-play.patch
# From xmms-crossfade-0.3.14/patches/ adapted from 1.2.10 to 1.2.11
Patch12:        %{name}-1.2.11-is_quitting.patch
Patch14:	%{name}-1.2.10-configfile-safe-write.patch
Patch15:	%{name}-1.2.10-reposition.patch
Patch16:	%{name}-1.2.11-ubuntu-CVE-2007-0653.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  gtk+-devel
BuildRequires:  esound-devel
BuildRequires:  arts-devel
BuildRequires:  alsa-lib-devel
BuildRequires:  libogg-devel
BuildRequires:  libvorbis-devel
BuildRequires:  mikmod-devel
BuildRequires:  gettext-devel
BuildRequires:  zlib-devel
BuildRequires:  libGL-devel
BuildRequires:  libXt-devel
BuildRequires:  libSM-devel
BuildRequires:  libXxf86vm-devel
BuildRequires:  desktop-file-utils

Requires:       unzip gtk2 at-spi
Requires(post): desktop-file-utils >= 0.9
Requires(postun): desktop-file-utils >= 0.9

# Skin packages can require this from xmms and all GUI compatible players
Provides:       xmms-gui

%description
XMMS is a multimedia (Ogg Vorbis, CDs) player for the X Window System
with an interface similar to Winamp's.  XMMS supports playlists and
streaming content and has a configurable interface.

%package        libs
Summary:        XMMS engine and core plugins
Group:          System Environment/Libraries

%description    libs
The X MultiMedia System player engine and core plugins.

%package        esd
Summary:        EsounD output plugin for XMMS
Group:          System Environment/Libraries
Requires:       %{name}-libs = %{epoch}:%{version}-%{release}

%description    esd
EsounD output plugin for the X MultiMedia System.

%package        devel
Summary:        Files required for XMMS plug-in development
Group:          Development/Libraries
Requires:       %{name}-libs = %{epoch}:%{version}-%{release}
Requires:       gtk+-devel
Requires:       pkgconfig

%description    devel
Files needed for building plug-ins for the X MultiMedia System.


%prep
%setup -q 
%patch0 -p1 -b .dso
# Set default output plugin to ALSA
%patch1 -p1 -b .audio
# Use RTLD_LAZY, not RTLD_NOW
%patch2 -p1 -b .lazy
# Change the default skin
%patch3 -p1 -b .default-skin
# Link arts dynamically and detect its presence for choosing output plugin
%patch5 -p1 -b .arts
# Don't link *everything* against alsa-lib
%patch6 -p1 -b .alsalib
# Use something that's more likely to work as the default cdrom mountpoint
%patch7 -p0 -b .cd-mountpoint
# Avoid multilib devel conflicts
%patch8 -p1 -b .multidevel
# Fix for crossfade >= 0.3.14 to work properly
%patch12 -p1 -b .crossfade
# Randomize playlists better
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch9 -p1 -b .playonclick
# Avoid standard rpaths on lib64 archs, --disable-rpath doesn't do it
perl -pi -e 's|/usr/lib|%{_libdir}|g' configure */configure

for f in AUTHORS ChangeLog README ; do
    iconv -f iso-8859-1 -t utf-8 -o $f.utf8 $f ; mv $f.utf8 $f
done

%build
%configure xmms.pc \
    --disable-dependency-tracking \
    --enable-kanji \
    --enable-texthack \
    --enable-ipv6 \
    --with-pic \
    --disable-static
%if %{with lpthreadhack}
%ifarch x86_64
find . -name Makefile | xargs perl -pi -e s/-lpthread//g # old libtool, x86_64
%endif
%endif
make
# smp_flags removed due to build issues

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
install -dm 755 %{buildroot}%{_datadir}/xmms/Skins
find %{buildroot} -name "*.la" | xargs rm -f

# On FC5 x86_64, some get created even though we pass --disable-static
rm -f %{buildroot}%{_libdir}/xmms/*/*.a

# https://bugzilla.redhat.com/213172
for bin in xmms wmxmms ; do
    install -Dpm 755 %{buildroot}%{_bindir}/$bin \
        %{buildroot}%{_libexecdir}/$bin
    sed -e "s|/usr/libexec/xmms|%{_libexecdir}/$bin|" %{SOURCE1} > \
        %{buildroot}%{_bindir}/$bin
    chmod 755 %{buildroot}%{_bindir}/$bin
done

# Desktop menu entry
desktop-file-install --vendor "" --dir=%{buildroot}%{_datadir}/applications %{SOURCE3}
# Desktop menu icon
install -Dpm 644 %{SOURCE2} \
    %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/xmms.xpm

install -Dpm 644 xmms.pc %{buildroot}%{_libdir}/pkgconfig/xmms.pc

%find_lang %{name}


%clean
rm -rf %{buildroot}


%post
gtk-update-icon-cache -qf %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database -q || :

%post libs -p /sbin/ldconfig

%postun
gtk-update-icon-cache -qf %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database -q || :

%postun libs -p /sbin/ldconfig


%files -f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING FAQ NEWS TODO README
%{_bindir}/xmms
%{_bindir}/wmxmms
%{_libexecdir}/xmms
%{_libexecdir}/wmxmms
%{_datadir}/applications/*.desktop
%{_datadir}/icons/hicolor/*x*/apps/xmms.xpm
%{_datadir}/xmms/
%{_mandir}/man1/*xmms.1*

%files libs
%defattr(-,root,root,-)
%doc COPYING
%{_libdir}/libxmms.so.*
%dir %{_libdir}/xmms/
%{_libdir}/xmms/Effect/
%{_libdir}/xmms/General/
%{_libdir}/xmms/Input/
%dir %{_libdir}/xmms/Output/
%{_libdir}/xmms/Output/libALSA.so
%{_libdir}/xmms/Output/libOSS.so
%{_libdir}/xmms/Output/libdisk_writer.so
%{_libdir}/xmms/Visualization/

%files esd
%defattr(-,root,root,-)
%{_libdir}/xmms/Output/libesdout.so

%files devel
%defattr(-,root,root,-)
%{_bindir}/xmms-config
%{_includedir}/xmms/
%{_libdir}/libxmms.so
%{_datadir}/aclocal/xmms.m4
%{_libdir}/pkgconfig/xmms.pc


%changelog
* Sun Feb 26 2012 cs@linux-administrator.com
- re-import
